@model myproject.Controllers.PLVC_Data

@{
    ViewData["Title"] = "PLVC Page";
    ViewBag.Titles = "PLVC Page 2";
}

@using (Html.BeginForm("Index", "Plvc", FormMethod.Post))
{
    <div class="row">
        <div class="col-12">
            <span>Filter Name:</span> @Html.TextBoxFor(m => m.Name, new { @class="form-control" })
            <input id="Submit" type="submit" value="submit" class="btn btn-primary" />
        </div>
    </div>
 
}

@Html.ActionLink("Create", "Create", "Plvc", new { @class="btn btn-primary" })

<h1>@Model.Name By Form</h1>

<table class="table table-bordered">
  <thead>
    <tr>
      <th class="text-center">#</th>
      <th class="text-center">Name</th>
      <th class="text-center">Type</th>
      <th class="text-center">Amount</th>
      <th class="text-center">Status</th>
      <th class="text-center">Action</th>
    </tr>
  </thead>
  <tbody>
    @foreach (var item in Model.Tables)
    {
        <tr>
            <th class="text-center">@item.Id</th>
            <td>@item.Name</td>
            <td class="text-center">@item.Type</td>
            <td class="text-end">@item.Amount.ToString("#,##0.00")</td>
            <td class="text-center">
                @if(item.Status == "อนุมัติ"){
                    <span class="badge bg-primary">@item.Status</span>
                }
                else if(item.Status == "รออนุมัติ")
                {
                    <span class="badge bg-warning text-dark">@item.Status</span>
                }
                else
                {
                    <span class="badge bg-danger">@item.Status</span>
                }
            </td>
            <td class="text-center">
                <a href="/plvc/Edit?Id=@item.Id" class="btn btn-warning">Edit</a>
                <a href="/plvc/Delete?Id=@item.Id" class="btn btn-danger">Delete</a>
            </td>
        </tr>
    }
  </tbody>
</table>

<hr />

<h1>@Model.Name By Javascript</h1>

<div class="row">
    <div class="col-12">
        <span>Filter Name:</span> <input type="text" id="txtName" />
        <input id="btnSearch" type="button" value="Search" class="btn btn-primary" />
    </div>
</div>

    <!-- Button trigger modal -->
<button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#staticCreateBackdrop">
  Create
</button>

<table class="table table-bordered">
  <thead>
    <tr>
      <th class="text-center">#</th>
      <th class="text-center">Name</th>
      <th class="text-center">Type</th>
      <th class="text-center">Amount</th>
      <th class="text-center">Status</th>
      <th class="text-center">Action</th>
    </tr>
  </thead>
  <tbody id="jsBody"></tbody>
</table>




<!-- Modal -->
<div class="modal fade" id="staticCreateBackdrop" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticCreateBackdropLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="staticCreateBackdropLabel">Create</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <div class="row">
            <div class="col-12">
                <span>Id: </span>
                <input type="text" id="staticCreateId" class="form-control" />
            </div>
            <div class="col-12">
                <span>Name: </span>
                <input type="text" id="staticCreateName" class="form-control" />
            </div>
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="button" id="staticCreateSubmit" class="btn btn-primary">Understood</button>
      </div>
    </div>
  </div>
</div>

<button type="button" id="btnModalEdit" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#staticEditBackdrop" style="display:none; ">
  Edit
</button>

<!-- Modal -->
<div class="modal fade" id="staticEditBackdrop" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticEditBackdropLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="staticEditBackdropLabel">Edit</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <div class="row">
            <div class="col-12">
                <span>Id: </span>
                <input type="text" id="staticEditId" class="form-control" />
            </div>
            <div class="col-12">
                <span>Name: </span>
                <input type="text" id="staticEditName" class="form-control" />
            </div>
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="button" id="staticEditSubmit" class="btn btn-primary">Understood</button>
      </div>
    </div>
  </div>
</div>


@section Scripts{
    <script type="text/javascript">
        $(document).ready(function () {
            console.log('ready.');

            RenderTables('Information');
        });

        $('#staticCreateSubmit').click(async function () {
            console.log('staticCreateSubmit.');

            const rawResponse = await fetch('/plvc/Create_Json', {
                method: 'POST',
                body: JSON.stringify({
                        Id: $('#staticCreateId').val(), 
                        Name: $('#staticCreateName').val()
                    })
            });
            const content = await rawResponse.json();

            console.log('staticCreateSubmit: ', content);

        });

        async function OnEdit(id){
            $('#btnModalEdit').click();

            const rawResponse = await fetch('/plvc/Edit_Json?Id=' + id, {
                method: 'GET',
            });

            const content = await rawResponse.json();

            console.log('btnModalEdit: ', content);

            $('#staticEditId').val(content.id);
            $('#staticEditName').val(content.name);
        }

        $('#staticEditSubmit').click(async function () {
            console.log('staticEditSubmit.');

            const rawResponse = await fetch('/plvc/Edit_Json', {
                method: 'POST',
                body: JSON.stringify({
                        Id: $('#staticEditId').val(), 
                        Name: $('#staticEditName').val()
                    })
            });
            const content = await rawResponse.json();

            console.log('staticEditSubmit: ', content);

        });

        async function OnDelete(id){

            const rawResponse = await fetch('/plvc/Delete?Id=' + id, {
                method: 'GET',
            });

            console.log('OnDelete: ', rawResponse);

            window.location.reload();

        }

        $('#btnSearch').click(function () {
            var name = $('#txtName').val();

            console.log('btnSearch: ', name);
            
            RenderTables(name);
        });

        async function RenderTables(filter){
            console.log('RenderTables.');

            var url = 'plvc/GetData?name=' + filter;

            let res = await fetch(url, {
                method: 'GET'
            });

            var result = await res.json();

            console.log('result: ', result);

            $('#jsBody').html('');

            result.data.tables.forEach(function (item, index){
                $('#jsBody').append(Const_RenderTables(item.id, item.name, item.type, item.amount, item.status));
            });

        }

        function Const_RenderTables(id, name, type, amount, status){
            var statusTxt = '';
            if(status == "อนุมัติ"){
                statusTxt = `<span class="badge bg-primary">${status}</span>`
            }
            else if(status == "รออนุมัติ")
            {
                statusTxt = `<span class="badge bg-warning text-dark">${status}</span>`
            }
            else
            {
                statusTxt = `<span class="badge bg-danger">${status}</span>`
            }

            return `
<tr>
    <th class="text-center">${id}</th>
    <td>${name}</td>
    <td class="text-center">${type}</td>
    <td class="text-end">${amount.toFixed(2)}</td>
    <td class="text-center">${statusTxt}</td>
    <td class="text-center">
        <button class="btn btn-warning" onClick="OnEdit(${id})">Edit</button>
        <button class="btn btn-danger" onClick="OnDelete(${id})">Delete</button>
    </td>
</tr>            
            `
        }
    </script>
}

